#include <windows.h>
#include <windowsx.h>
#include "main.h"
#include "file.h"

int OpenFile(HWND hEdit);
int SaveFile(HWND hEdit);
int SaveFileAs(HWND hEdit);
int NewFile(HWND hEdit);

int NewFile(HWND hEdit){
	Edit_SetText(hEdit,"");
	SetWindowText(GetParent(hEdit),"SBasicForXp[NameLess]");
	strcpy(szFile,"");

	return 0;
}
int SaveFileAs(HWND hEdit){
    OPENFILENAME ofn;
    HANDLE hFile;
    DWORD dwAccBytes;

    char *lpszBuf;
    int nLen;
    HGLOBAL hMem;

    nLen = GetWindowTextLength(hEdit);
    hMem = GlobalAlloc(GHND, sizeof(char) * nLen + 1);
    lpszBuf = (char *)GlobalLock(hMem);

    GetWindowText(hEdit, lpszBuf, nLen + 1);

    memset(&ofn, 0, sizeof(OPENFILENAME));
    ofn.lStructSize = sizeof(OPENFILENAME);
    ofn.hwndOwner = hEdit;
    ofn.lpstrFilter = 
        "text(*.txt)\0*.txt\0All files(*.*)\0*.*\0\0";
    ofn.lpstrFile = szFile;
    ofn.lpstrFileTitle = szFileTitle;
    ofn.nFilterIndex = 1;
    ofn.nMaxFile = MAX_PATH;
    ofn.nMaxFileTitle = MAX_PATH;
    ofn.Flags = OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY;
    ofn.lpstrDefExt = "txt";
    ofn.lpstrTitle = "Name And Save";

    if(GetSaveFileName(&ofn) == 0)
        return -1;
    hFile = CreateFile(szFile, GENERIC_WRITE, 0, NULL,
		CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
    WriteFile(hFile, lpszBuf, (DWORD)strlen(lpszBuf), 
              &dwAccBytes, NULL);
    wsprintf(szTitle, szTitle_org, szFileTitle, nLen);
    SetWindowText(GetParent(hEdit), szTitle);
    if(CloseHandle(hFile) == 0)
        MessageBox(hEdit, "Error CloseHandle", "Error", MB_OK);
    SendMessage(hEdit, EM_SETMODIFY, FALSE, 0);
    GlobalUnlock(hMem);
    GlobalFree(hMem);

    return 0;
}

int SaveFile(HWND hEdit){
	HANDLE hFile;
    DWORD dwAccBytes;
    int nLen;
    char *lpszBuf;
    HGLOBAL hMem;

    if (strcmp(szFile,"") == 0){
        MessageBox(hEdit,"Don't Name File","SBasicForXp",MB_OK);
        SaveFileAs(hEdit);
        return -1;
    }

    nLen = GetWindowTextLength(hEdit);
    hMem = GlobalAlloc(GHND, sizeof(char) * nLen + 1);
    lpszBuf = (char *)GlobalLock(hMem);

    GetWindowText(hEdit,lpszBuf,nLen + 1);

    hFile = CreateFile(szFile,GENERIC_WRITE,0,NULL, 
                       TRUNCATE_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
    WriteFile(hFile,lpszBuf,(DWORD)strlen(lpszBuf),&dwAccBytes,NULL);

    GlobalUnlock(hMem);
    GlobalFree(hMem);
    SendMessage(hEdit,EM_SETMODIFY,FALSE,0);
    wsprintf(szTitle,szTitle_org,szFileTitle,nLen);
    SetWindowText(GetParent(hEdit),szTitle);
    if (CloseHandle(hFile) == 0){
        MessageBox(hEdit,"Error CloseHandle","Error",MB_OK);
        return -1;
    }

    return 0;
}


int OpenFile(HWND hEdit){
	HWND hMain;
	DWORD dwSize = 0L;
	OPENFILENAME ofn;
	HANDLE hFile;
	DWORD dwAccBytes;
	char *lpszBuf;

	HGLOBAL hMem;

	memset(&ofn,0,sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = hEdit;
	ofn.lpstrFilter = "text(*.txt)\0*.txt\0All files(*.*)\0.*\0\0";
	ofn.lpstrFile = szFile;
	ofn.lpstrFileTitle = szFileTitle;
	ofn.nMaxFile = MAX_PATH;
	ofn.nMaxFileTitle = MAX_PATH;
	ofn.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
	ofn.lpstrDefExt = "txt";
	ofn.lpstrTitle = "SBasicForXpFileOpen";

	if(GetOpenFileName(&ofn) == 0)
		return -1;

	hFile = CreateFile(szFile,GENERIC_READ,0,NULL,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
	dwSize = GetFileSize(hFile,NULL);
	hMem = GlobalAlloc(GHND,sizeof(char) * dwSize + 1);
	if(hMem == NULL){
		MessageBox(hEdit,"mۂł܂","SBasicForXp",MB_ICONEXCLAMATION | MB_OK);
		return -1;
	}
	lpszBuf = (char *)GlobalLock(hMem);

	ReadFile(hFile,lpszBuf,dwSize,&dwAccBytes,NULL);
	lpszBuf[dwAccBytes] = '\0';
	Edit_SetText(hEdit,lpszBuf);
	wsprintf(szTitle,szTitle_org,szFileTitle,dwSize);
	hMain = GetParent(hEdit);
	SetWindowText(hMain,szTitle);
	CloseHandle(hFile);
	GlobalUnlock(hMem);
	GlobalFree(hMem);

	return 0;
}